(in-package "ACL2")

; The following comment line tells the build system that if *acl2-exports*
; changes, then every book that uses this file should be recertified:
; (depends-on "build/acl2-exports.certdep" :dir :system)

;; Package for hexadecimal printing
(defpkg "PRB"
  (union-eq '(fmx)
	    (union-eq *acl2-exports*
		      *common-lisp-symbols-from-main-lisp-package*)))


(defconst *ihs-symbols*
    '(ZBP WRB-TYPE WRB-FIELD-TYPE WRB-FIELD WRB UNSIGNED-BYTE-P-WRB
     UNSIGNED-BYTE-P-RDB UNSIGNED-BYTE-P-PLUS UNSIGNED-BYTE-P-LSHU
     UNSIGNED-BYTE-P-LOGXOR UNSIGNED-BYTE-P-LOGRPL
     UNSIGNED-BYTE-P-LOGREV UNSIGNED-BYTE-P-LOGNOTU
     UNSIGNED-BYTE-P-LOGIOR UNSIGNED-BYTE-P-LOGHEAD
     UNSIGNED-BYTE-P-LOGEXTU UNSIGNED-BYTE-P-LOGAPP
     UNSIGNED-BYTE-P-LOGAND UNSIGNED-BYTE-P-FORWARD
     UNSIGNED-BYTE-P-BASE-CASE UNSIGNED-BYTE-P-ASHU UNSIGNED-BYTE-P-ASH
     UNSIGNED-BYTE-P-0 UNSIGNED-BYTE-P* TRUNCATE-TYPE TRUNCATE-REM-ELIM
     TRUNCATE-MINUS TRUNCATE-CANCEL-* TRUNCATE-BOUNDS TRUNCATE-=-X/Y
     THIS-NEEDS-TO-BE-ADDED-TO-QUOTIENT-REMAINDER-LEMMAS
     SUB1-LOGCDR-INDUCTION-3 SUB1-LOGCDR-INDUCTION-2-W/CARRY
     SUB1-LOGCDR-INDUCTION-2 SUB1-LOGCDR-INDUCTION-1 SIMPLIFY-MOD-+-MOD
     SIMPLIFY-MOD-* SIMPLIFY-LOGXOR SIMPLIFY-LOGIOR SIMPLIFY-LOGAND
     SIMPLIFY-BIT-FUNCTIONS SIGNED-BYTE-P-LOGSAT SIGNED-BYTE-P-LOGOPS
     SIGNED-BYTE-P-LOGEXT SIGNED-BYTE-P-FORWARD
     SIGNED-BYTE-P-BASE-CASES SIGNED-BYTE-P*
     REWRITE-TRUNCATE-X*Y-Z-RIGHT REWRITE-TRUNCATE-X*Y-Z-LEFT
     REWRITE-THEORY REWRITE-MOD-MOD REWRITE-LINEAR-EQUALITIES-TO-IFF
     REWRITE-FREE-THEORY REWRITE-FLOOR-X*Y-Z-RIGHT
     REWRITE-FLOOR-X*Y-Z-LEFT REWRITE-FLOOR-MOD REM-X-Y-=-X REM-TYPE
     REM-MINUS REM-BOUNDS REM-=-0 REDUCE-INTEGERP-+-CONSTANT
     RDB-UPPER-BOUND RDB-TYPE RDB-TEST RDB-FIELD RDB RATIONALP-MOD
     PAIRWISE-LIST NOT-RATIONALP-RATIONALP-UNARY---PLUS
     NOT-RATIONALP-RATIONALP-PLUS NORMALIZE-EQUAL-0
     NORMALIZE-EQUAL-/-TO-* NORMALIZE-<-MINUS-/ NORMALIZE-<-/-TO-*-3
     NORMALIZE-<-/-TO-* NIQ-TYPE NIQ-BOUNDS MOD-X-Y-=-X+Y MOD-X-Y-=-X
     MOD-X-I*J MOD-X+I*K-I*J MOD-TYPE MOD-MINUS MOD-BOUNDS MOD-=-0
     MOD-+-CANCEL-0 MOD-+ MLAMBDA-FN LSHU-TYPE LSHU LOGXOR-=-0 LOGXOR*
     LOGTAIL-UNSIGNED-BYTE-P LOGTAIL-TYPE LOGTAIL-SIZE-0
     LOGTAIL-LOGTAIL LOGTAIL-LOGRPL LOGTAIL-LOGHEAD LOGTAIL-LOGAPP
     LOGTAIL-LESSP LOGTAIL-LEQ LOGTAIL-IDENTITY LOGTAIL-EQUAL-0
     LOGTAIL-0-I LOGTAIL* LOGTAIL LOGSAT-TYPE LOGSAT-BOUNDS LOGSAT
     LOGRPL-TYPE LOGRPL-LOGRPL-RIGHT LOGRPL-LOGRPL-LEFT
     LOGRPL-LOGHEAD-I-I LOGRPL-I-I LOGRPL-0 LOGRPL LOGREV1 LOGREV-TYPE
     LOGREV LOGNOTU-TYPE LOGNOTU-LOGNOTU LOGNOTU LOGNOT-LOGNOT LOGNOT*
     LOGMASKP-LOGMASK LOGMASKP-EXPT-2-N-MINUS-1 LOGMASKP* LOGMASKP
     LOGMASK-TYPE LOGMASK LOGIOR-=-0 LOGIOR* LOGHEAD-UPPER-BOUND
     LOGHEAD-TYPE LOGHEAD-SIZE-0 LOGHEAD-LOGRPL LOGHEAD-LOGHEAD
     LOGHEAD-LOGEXTU LOGHEAD-LOGAPP-LOGHEAD-LOGTAIL LOGHEAD-LOGAPP
     LOGHEAD-LEQ LOGHEAD-IDENTITY LOGHEAD-0-I LOGHEAD-+-LOGHEAD
     LOGHEAD-+-CANCEL-0 LOGHEAD-+-CANCEL LOGHEAD* LOGHEAD LOGEXTU-TYPE
     LOGEXTU-AS-LOGHEAD LOGEXTU-0 LOGEXTU LOGEXT-TYPE LOGEXT-IDENTITY
     LOGEXT-BOUNDS LOGEXT-+-LOGEXT LOGEXT-+-CANCEL LOGEXT* LOGEXT
     LOGCONS-TYPE LOGCONS-<-0 LOGCONS LOGCDR-TYPE LOGCDR-LOGCONS
     LOGCDR-INDUCTION-3 LOGCDR-INDUCTION-2 LOGCDR-INDUCTION-1
     LOGCDR-I+2*J LOGCDR-<-0 LOGCDR-2*I LOGCDR LOGCAR-TYPE
     LOGCAR-LOGRPL LOGCAR-LOGHEAD LOGCAR-LOGCONS LOGCAR-LOGCDR-ELIM
     LOGCAR-LOGAPP LOGCAR-I+2*J LOGCAR-2*I LOGCAR LOGBITP-LOGTAIL
     LOGBITP-LOGRPL LOGBITP-LOGNOTU LOGBITP-LOGNOT LOGBITP-LOGHEAD
     LOGBITP-LOGAPP LOGBITP-0-MINUS-1 LOGBITP* LOGBIT-TYPE
     LOGBIT-LOGTAIL LOGBIT-LOGRPL LOGBIT-LOGNOTU LOGBIT-LOGNOT
     LOGBIT-LOGHEAD LOGBIT-LOGAPP LOGBIT-0-MINUS-1 LOGBIT LOGAPP-TYPE
     LOGAPP-LOGHEAD-LOGTAIL LOGAPP-<-0 LOGAPP-0 LOGAPP* LOGAPP
     LOGANDC2-TYPE LOGANDC1-TYPE LOGAND-WITH-MASK LOGAND-UPPER-BOUND
     LOGAND-TYPE LOGAND-LOGXOR LOGAND-LOGIOR LOGAND-=-MINUS-1 LOGAND*
     LINEARIZE-REM LINEARIZE-MOD LET*$FN JUSTIFY-LOGCDR-INDUCTION
     JUSTIFY-FLOOR-RECURSION INTEGERP-REM INTEGERP-MOD
     INTEGERP-I/J-INTEGERP-FORWARD INTEGERP-+-MINUS-*
     INTEGER-TRUNCATE-AS-NIQ INTEGER-LENGTH* IMOD-TYPE IMOD IFLOOR-TYPE
     IFLOOR HOW-COULD-THIS-HAVE-BEEN-LEFT-OUT?? FLOOR-X+I*K-I*J
     FLOOR-UNSIGNED-BYTE-P FLOOR-TYPE-4 FLOOR-TYPE-3 FLOOR-TYPE-2
     FLOOR-TYPE-1 FLOOR-MOD-ELIM FLOOR-MINUS FLOOR-FLOOR-INTEGER
     FLOOR-CANCEL-*-2 FLOOR-CANCEL-* FLOOR-BOUNDS FLOOR-AS-TRUNCATE
     FLOOR-=-X/Y FLOOR-+ FALSIFY-UNSIGNED-BYTE-P FALSIFY-SIGNED-BYTE-P
     EXPT2-TYPE EXPT2 EXPT-WITH-VIOLATED-GUARDS EQUAL-LOGCONS
     EQUAL-INTEGER-LENGTH-0 DIFFERENCE-UNSIGNED-BYTE-P
     DEFWORD-UPDATER-NAME DEFWORD-UPDATER-DEFINITIONS
     DEFWORD-TUPLE-P-LISTP DEFWORD-TUPLE-P DEFWORD-STRUCT-P
     DEFWORD-KEYWORD-UPDATER-BODY DEFWORD-KEYWORD-UPDATER
     DEFWORD-KEYWORD-FIELD-ALIST DEFWORD-GUARDS DEFWORD-ACCESSOR-NAME
     DEFWORD-ACCESSOR-DEFINITIONS DEFUN-TYPE/EXEC-THEORY-FN
     DEFUN-THEORY-FN DEFINITION-THEORY DEFINITION-FREE-THEORY
     CONSTANT-SYNTAXP COMMUTATIVITY-OF-LOGXOR COMMUTATIVITY-OF-LOGIOR
     COMMUTATIVITY-OF-LOGAND CANCEL-MOD-+-3 CANCEL-MOD-+
     CANCEL-FLOOR-+-3 CANCEL-FLOOR-+ CANCEL-EQUAL-LOGNOTU
     CANCEL-EQUAL-LOGNOT CANCEL-EQUAL-+-* BSP 
     BSPP-BSP BSPP BSP-SIZE-TYPE
     BSP-SIZE BSP-POSITION-TYPE BSP-POSITION BITP-RDB-BSP-1 BITP-MOD-2
     BITP-LOGHEAD-1 BITP-FORWARD BITP-BFIX 
     BIT-FUNCTIONS-TYPE
     BIND-WORD-TO-BITS-FN BFIX-BITP BFIX
     BACKCHAIN-SIGNED-BYTE-P-TO-UNSIGNED-BYTE-P
;     BITP
;     B-XOR B-ORC2 B-ORC1
;     B-NOT B-NOR B-NAND B-IOR B-EQV B-ANDC2 B-ANDC1 B-AND
     ASSOCIATIVITY-OF-LOGAPP ASHU-TYPE ASHU ASH-GOES-TO-0 ASH-0 ASH*))

(defconst *rtl-symbols*
    '(*-STRONGLY-MONOTONIC *-STRONGLY-MONOTONIC-NEGATIVE-MULTIPLIER
    *-WEAKLY-MONOTONIC *-WEAKLY-MONOTONIC-NEGATIVE-MULTIPLIER
    /-STRONGLY-MONOTONIC /-WEAKLY-MONOTONIC A1 A10 A12 A13 A14 A15 A16
    A2 A3 A4 A5 A6 A7 A8 A9 ABS-AWAY ABS-TRUNC ABS-TYPE ALREADY-SIG
    ASH-REWRITE AWAY AWAY-0 AWAY-AWAY AWAY-DIFF AWAY-DIFF-EXPO
    AWAY-DIFF-POS AWAY-EXACTP-B AWAY-EXACTP-C AWAY-LOWER-BOUND
    AWAY-LOWER-POS AWAY-MINUS AWAY-MONOTONE AWAY-NEG AWAY-POS
    AWAY-REWRITE AWAY-SHIFT AWAY-UPPER-1 AWAY-UPPER-2 AWAY-UPPER-3 BIAS
    BIAS-NON-NEGATIVE-INTEGERP-TYPE-PRESCRIPTION BIT+EXPT-2 
    BITN+MULT BITN-0-0 BITN-BITN-0 BITN-BVECP BITN-BVECP-0 BITN-BVECP-1
    BITN-CAT-1 BITN-CAT-2 BITN-EXPT BITN-FORCE-1 BITN-FORCE-2
    BITN-LOGAND BITN-LOGIOR BITN-REC-0 BITN-REC-POS-DEF BITN-REM-BITN
    BITN-REWRITE BITN-SETBITS-1 BITN-SETBITS-2 BITN-SETBITS-3
    BITN-SHIFT-2 BITN-SHIFT-3 BITS- BITS-0-0 BITS-CAT-1 BITS-CAT-2
    BITS-CAT-3 BITS-COMP1 BITS-LOGAND BITS-LOGIOR BITS-LOGXOR-2
    BITS-LOGXOR-UPPER-SLICE BITS-N-N-REWRITE BITS-NEG-1 BITS-REDUCE
    BITS-REM BITS-SETBITS-1 BITS-SETBITS-2 BITS-SETBITS-3
    BITS-SETBITS-4 BITS-SETBITS-5 BITS-SETBITS-6 BITS-SHIFT-1
    BITS-SHIFT-2 BITS-SHIFT-3 BITS-SHIFT-4 BITS-TAIL BVECP BVECP+1
    BVECP-1-REWRITE BVECP-BITN BVECP-BITS BVECP-BITS-0 BVECP-CAT
    BVECP-COMP1 BVECP-EXACTP BVECP-EXPO BVECP-FL BVECP-FORWARD
    BVECP-LOGAND BVECP-LOGIOR BVECP-LOGXOR BVECP-MULCAT
    BVECP-REBIAS-DOWN BVECP-REBIAS-UP BVECP-SETBITS BVECP-SHFT
    BVECP-SHIFT CAT CAT-0-REWRITE CAT-ASSOC CAT-BITN-BITS CAT-BITS-BITN
    CAT-BITS-BITS CAT-NAT CG CG+INT-REWRITE CG-DEF-LINEAR CG-INT-2
    CG-MONOTONE-LINEAR CG/INT-REWRITE COMP1 COMP1-2+1 COMP1-BITN
    COMP1-COMP1-REWRITE COMP1-FL-REWRITE COMP1-LOGXOR COMP1-REM-2
    DDECODE DDECODE-DENCODE DENCODE DENCODE-DDECODE DENCODINGP
    DENCODINGP-DENCODE DENORMAL-SPACING DREPP DREPP-DDECODE DREPP-SPD
    DRND DRND-0 DRND-AWAY-NEVER-GOES-TOWARD-ZERO
    DRND-AWAY-SKIPS-NO-DENORMALS DRND-DIFF DRND-INF-NEVER-GOES-DOWN
    DRND-INF-SKIPS-NO-DENORMALS DRND-MINF-NEVER-GOES-UP
    DRND-MINF-SKIPS-NO-DENORMALS DRND-OF-DREPP-IS-NOP DRND-REWRITE
    DRND-SPN-IS-SPN-GENERAL DRND-TRUNC-NEVER-GOES-AWAY-FROM-ZERO
    DRND-TRUNC-SKIPS-NO-DENORMALS EDECODE EDECODE-EENCODE EENCODE
    EENCODE-EDECODE EENCODINGP EENCODINGP-EENCODE EENCODINGP-NOT-ZERO
    EEXPOF EREPP EREPP-EDECODE ESGNF ESIGF EXACTP- EXACTP-2**N
    EXACTP-<= EXACTP-RND EXACTP-SIG-X EXACTP2 EXPO-2**N
    EXPO-AWAY-LOWER-BOUND EXPO-DDECODE EXPO-EDECODE EXPO-IDECODE
    EXPO-LOWER-BOUND EXPO-MINUS EXPO-MONOTONE EXPO-NDECODE EXPO-ODD
    EXPO-PROD-LOWER EXPO-PROD-UPPER EXPO-SHIFT EXPO-TRUNC
    EXPO-UPPER-BOUND EXPO-X+2**K EXPO<= EXPO>= EXPT-POS FL
    FL+INT-REWRITE FL-DEF-LINEAR FL-HALF FL-INT-2 FL-MONOTONE-LINEAR
    FL-WEAKLY-MONOTONIC FL/INT-REWRITE FLIP FP+ IDECODE IDECODE-IENCODE
    IEEE-MODE-P IEEE-MODE-P-FLIP IEEE-MODE-P-IMPLIES-ROUNDING-MODE-P
    IENCODE IENCODE-IDECODE IENCODINGP IENCODINGP-IENCODE IEXPOF INF
    INT-CG-RULES INT-FL-RULES INT-TRUNC INTEGERP-COMP1-NAT
    INTEGERP-RATIONALP INTEGERP-REM INTEGERP-REM-REWRITE IREPP
    IREPP-IDECODE ISGNF ISIGF KAP KP LAM0 LAM1 LAM2 LAM3 LAM4 LAMB LAMG
    LAMT LAMZ LOG2 LOGAND-0-Y LOGAND-1-X LOGAND-ASSOCIATIVE LOGAND-BND
    LOGAND-COMMUTATIVE LOGAND-FL-2-REWRITE LOGAND-LOGIOR LOGAND-ONES
    LOGAND-REM-2 LOGAND-REWRITE LOGAND-SELF LOGAND-X-0 LOGAND-X-1
    LOGIOR-0-Y LOGIOR-1-X LOGIOR-ASSOCIATIVE LOGIOR-COMMUTATIVE
    LOGIOR-FL-2-REWRITE LOGIOR-LOGAND LOGIOR-LOGAND-2 LOGIOR-REM-2
    LOGIOR-REWRITE LOGIOR-SELF LOGIOR-X-0 LOGIOR-X-1 LOGOP-2-INDUCT
    LOGOP-2-N-INDUCT LOGOP-3-INDUCT LOGXOR-0-Y LOGXOR-ASSOCIATIVE
    LOGXOR-BITN LOGXOR-COMMUTATIVE LOGXOR-DEF-REWRITE
    LOGXOR-FL-2-REWRITE LOGXOR-REM-2 LOGXOR-REWRITE-2 LOGXOR-SELF
    LOGXOR-X-0 MINF MONOTONE-NEAR MONOTONE-NEAR+ MONOTONE-RND MULCAT
    MULCAT-0 MULCAT-1 MULCAT-N-1 N<=FL-LINEAR N>=CG-LINEAR NATP*
    NATP+ NATP- NATP-BITN NATP-BITS NATP-BVECP NATP-COMP1
    NATP-COMPOUND-RECOGNIZER NATP-EXPT NATP-INDUCT NATP-INTEGERP
    NATP-LOGAND NATP-LOGIOR NATP-LOGXOR NATP-REBIAS-DOWN NATP-REBIAS-UP
    NATP-REM NATP-REM-REWRITE NATP-SETBITS NATP-SHFT NATP>=0 NDECODE
    NDECODE-NENCODE NEAR NEAR+ NEAR+-0 NEAR+-EXACTP-B NEAR+-EXACTP-C
    NEAR+-EXACTP-D NEAR+-MINUS NEAR+-NEG NEAR+-POS NEAR+-SHIFT NEAR-0
    NEAR-EXACTP-B NEAR-EXACTP-C NEAR-EXACTP-D NEAR-MINUS NEAR-NEG
    NEAR-POS NEAR-SHIFT NEAR-WITNESS NENCODE NENCODE-NDECODE NENCODINGP
    NENCODINGP-NENCODE NEXT-DENORMAL NK>=K-LINEAR
    NO-DENORMAL-IS-CLOSER-THAN-WHAT-DRND-NEAR-RETURNS NREPP
    NREPP-NDECODE NREPP-SPN ODD PLUS-AWAY-COROLLARY
    PLUS-TRUNC-COROLLARY POINT-LEFT-MEASURE POINT-RIGHT-MEASURE
    POSITIVE-SPD POSITIVE-SPN QUOT-BND RATIONALP-REM
    RATIONALP-REM-REWRITE RE REARRANGE-FRACTIONAL-COEFS-<
    REARRANGE-FRACTIONAL-COEFS-EQUAL REARRANGE-NEGATIVE-COEFS-<
    REARRANGE-NEGATIVE-COEFS-EQUAL REBIAS-EXPO RECURSION-BY-POINT-LEFT
    RECURSION-BY-POINT-RIGHT REM-0 REM-1 REM-2*I+1-REWRITE
    REM-2*I-REWRITE REM-BND-1 REM-BND-2 REM-BND-3 REM-COMP1-REWRITE
    REM-DIFF REM-EQUAL REM-LOGAND-REWRITE REM-LOGIOR REM-LOGXOR-REWRITE
    REM-MULT REM-MULT-2 REM-OF-REM REM-PROD REM-REM-SUM REM-SUM RND
    RND-0 RND-CONST RND-DIFF RND-EXACTP-B RND-EXACTP-C RND-EXACTP-D
    ROUNDING-MODE-P ROUNDING-MODE-P-FLIP SETBITS SETBITS-REWRITE-1
    SETBITS-REWRITE-2 SGN* SGN-AWAY SGN-DDECODE SGN-EDECODE
    SGN-IDECODE SGN-NDECODE SGN-NEAR+-2 SGN-NEAR-2 SGN-RND SGN-TRUNC
    SHFT SIG-DDECODE SIG-EDECODE SIG-IDECODE SIG-LOWER-BOUND
    SIG-MINUS SIG-NDECODE SIG-SHIFT SIG-SIG SIG-UPPER-BOUND SIGM
    SMALLEST-POSITIVE-DENORMAL SMALLEST-POSITIVE-NORMAL SMALLEST-SPD
    SMALLEST-SPN STICKY STICKY-0 STICKY-1 STICKY-MINUS STICKY-POS
    SUMBITS SUMBITS-BITS SUMBITS-THM TAU TRUNC TRUNC-0 TRUNC-EXACTP-B
    TRUNC-EXACTP-C TRUNC-LOWER-1 TRUNC-LOWER-3 TRUNC-LOWER-4
    TRUNC-LOWER-POS TRUNC-MINUS TRUNC-MONOTONE TRUNC-NEG TRUNC-POS
    TRUNC-REWRITE TRUNC-SHIFT TRUNC-TRUNC TRUNC-UPPER-BOUND
    TRUNC-UPPER-POS EXPO SIG SGN EXACTP))


(defpkg "BV"
; Matt K. mod April 2016: removed bitp to avoid name clash, now that bitp is
; defined in ACL2.
  (set-difference-eq
   (union-eq *acl2-exports*
             (union-eq *common-lisp-symbols-from-main-lisp-package*
                       *ihs-symbols*))
   '(bitp)))

